package org.jeneva;

import org.jeneva.impl.PropertyMeta;
import org.jeneva.validation.IChecker;
import org.jeneva.validation.IMath;
import org.jeneva.validation.IPathHelper;

/**
 * defines Jeneva context object methods
 */
public interface IJenevaContext {

	/**
	 * gets singleton instance of the PathHelpr class
	 */
	public IPathHelper getPathHelper();

	/**
	 * gets singleton instance of the Checker class
	 */
	public IChecker getChecker();

	/**
	 * gets singleton instance of the Math class
	 */
	public IMath getMath();

	/**
	 * generates an array of ProperyMeta class from a domain class
	 * @param type domain class
	 */
	public PropertyMeta[] getPropertyDefs(Class<?> type);

	/**
	 * creates a property parser instance based on property class
	 * @param name property name
	 * @param propertyClass property class
	 * @param propertyClassType property class type
	 * @param annotation Dto annotation instance
	 * @return parser instance
	 */
	IParser buildParser(String name, Class<?> propertyClass, PropertyMeta.ClassType propertyClassType, Dto annotation);
}
